function log(message) {
	Application.sharedInstance().showHUD(message, self.window, 30);
}

function dump(obj) {
	var message = "";
	for (var item in obj) {
		message = message + item + ": " + obj[item] + "\n";
	}

	log(message);
}

function isNumOrLetter(charCode) {
	if ((charCode > 47 && charCode < 58) || (charCode > 64 && charCode < 91) || (charCode > 96 && charCode < 123))
		return 1;

	return 0;
}

function ToDBC(str) {
	var tmp = "";
	for (var i = 0; i < str.length; i++) {
		let needConvert = 1;
		if (i - 1 >= 0 && (isNumOrLetter(str.charCodeAt(i-1)) || str.charCodeAt(i-1) == 32))
		{
			if (i + 1 < str.length && (isNumOrLetter(str.charCodeAt(i+1)) || str.charCodeAt(i+1) == 32))
			{
				needConvert = 0;
			}
		}
		else if (i + 1 < str.length && (isNumOrLetter(str.charCodeAt(i+1)) || str.charCodeAt(i+1) == 32))
		{
			if (i - 1 >= 0 && (isNumOrLetter(str.charCodeAt(i-1)) || str.charCodeAt(i-1) == 32))
			{
				needConvert = 0;
			}
		}

		if (needConvert && (
				(str.charCodeAt(i) > 32 && str.charCodeAt(i) < 48) ||
				(str.charCodeAt(i) > 57 && str.charCodeAt(i) < 64) ||
				(str.charCodeAt(i) > 90 && str.charCodeAt(i) < 97) ||
				(str.charCodeAt(i) > 122 && str.charCodeAt(i) < 127)
			)) {
			tmp = tmp + String.fromCharCode(str.charCodeAt(i) + 65248);
		} else {
			tmp = tmp + str[i];
		}
	}
	return tmp;
}

function ToCDB(str) {
	var tmp = "";
	for (var i = 0; i < str.length; i++) {
		if (str.charCodeAt(i) == 12288) {
			tmp += String.fromCharCode(str.charCodeAt(i) - 12256);
			continue;
		}
		if (str.charCodeAt(i) > 65280 && str.charCodeAt(i) < 65375) {
			tmp += String.fromCharCode(str.charCodeAt(i) - 65248);
		} else {
			tmp += String.fromCharCode(str.charCodeAt(i));
		}
	}
	return tmp
}

JSB.newAddon = function (mainPath) {
	var newAddonClass = JSB.defineClass('APunctuation : JSExtension', /*Instance members*/ {
			//Window initialize
			sceneWillConnect: function () {},
			//Window disconnect
			sceneDidDisconnect: function () {},
			//Window resign active
			sceneWillResignActive: function () {},
			//Window become active
			sceneDidBecomeActive: function () {},
			notebookWillOpen: function (notebookid) {
				try {
					NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onProcessExcerptText:', 'ProcessNewExcerpt');
					NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onProcessExcerptText:', 'ChangeExcerptRange');
				} catch (err) {
					log(err);
				}
			},
			notebookWillClose: function (notebookid) {
				NSNotificationCenter.defaultCenter().removeObserverName(self, 'ProcessNewExcerpt');
				NSNotificationCenter.defaultCenter().removeObserverName(self, 'ChangeExcerptRange');
			},
			documentDidOpen: function (docmd5) {},
			documentWillClose: function (docmd5) {},
			// processing excerpt text
			onProcessExcerptText: function (sender) {
				try {
					if (!Application.sharedInstance().checkNotifySenderInWindow(sender, self.window)) return; //Don't process message from other window
					var noteid = sender.userInfo.noteid;
					var note = Database.sharedInstance().getNoteById(noteid);
					if (note && note.excerptText && note.excerptText.length > 0) {
						var timerCount = 0;
						NSTimer.scheduledTimerWithTimeInterval(1, true, function (timer) {
							var text = note.excerptText;
							if (text && text.length) {
								note.excerptText = ToDBC(text);
								Database.sharedInstance().setNotebookSyncDirty(note.notebookId);
								NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('RefreshAfterDBChange', self, {
									topicid: note.notebookId
								});
							}
							timerCount++;
							if (timerCount >= 4) {
								timer.invalidate();
							}
						});
					}
				} catch (err) {
					Application.sharedInstance().showHUD(err, self.window, 120);
				}
			},
		},
		/*Class members*/
		{
			addonDidConnect: function () {},
			addonWillDisconnect: function () {},
			applicationWillEnterForeground: function () {},
			applicationDidEnterBackground: function () {},
			applicationDidReceiveLocalNotification: function (notify) {},
		});
	return newAddonClass;
};